# Request proforma refund

Use the **requestProformaRefund** method to initiate a refund for a paid partner proforma.

## Request parameters

<table><thead><tr><th width="155.800048828125">Parameter</th><th>Type / Description</th></tr></thead><tbody><tr><td><code>Uuid</code></td><td><strong>Required (string)</strong><br>Partner unique identifier.</td></tr><tr><td><code>proformaNumber</code></td><td><strong>Required (string)</strong><br>The unique identifier of a partner proforma in the 2Checkout system.</td></tr><tr><td><code>comment</code></td><td><strong>Optional (string)</strong><br>Refund reason/additional comments. Can be NULL.</td></tr></tbody></table>

### Request sample

```php
<?php

declare(strict_types=1);

class Configuration
{
    public const MERCHANT_CODE = '';
    public const MERCHANT_KEY = '';
    public const URL = 'http://api.2checkout.com/soap/6.0';
    public const ACTION = 'requestProformaRefund';
    public const ADDITIONAL_OPTIONS = null;
    //array or JSON
    public const PAYLOAD = <<<JSON
{
            "Uuid": "96f2a739-ca6f-46bd-af03-f42e5048f653",
            "ProformaNumber": "6",
            "Comment": "Comment"
}
JSON;
}

class Client
{
    public function call(
        string $url = Configuration::URL,
               $payload = Configuration::PAYLOAD,
        string $action = Configuration::ACTION
    ): ?object
    {
        if (is_array($payload)) {
            $payload = json_encode($payload);
        }
        if (!empty($payload)) {
            // SoapClient works with objects(StdClass)
            $payload = json_decode($payload);
        }

        $soapClient = $this->getClient($url);
        $sessionId = $this->getSession($soapClient);

        $args = array_filter([$sessionId, $payload]);

        return $soapClient->$action(...$args);
    }

    public function getClient(string $url): SoapClient
    {
        return new SoapClient(
            $url . '?wsdl',
            [\
                'location' => $url,\
                'cache_wsdl' => WSDL_CACHE_NONE,\
            ]
        );
    }

    public function getSession(SoapClient $client)
    {
        $date = gmdate('Y-m-d H:i:s');
        $merchantCode = Configuration::MERCHANT_CODE;
        $key = Configuration::MERCHANT_KEY;
        $string = strlen($merchantCode) . $merchantCode . strlen($date) . $date;
        $hash = hash_hmac('md5', $string, $key);
        // $client->__setCookie('XDEBUG_SESSION', 'PHPSTORM');
        return $client->login($merchantCode, $date, $hash);
    }
}

try {
    $client = new Client();
    var_dump($client->call());
} catch (Exception $ex) {
    var_dump($ex);
}
```

## Response parameters

<table><thead><tr><th width="118.5999755859375">Parameter</th><th>Type / Description</th></tr></thead><tbody><tr><td><code>result</code></td><td><strong>Boolean</strong><br>True or false</td></tr></tbody></table>

## Errors

<table><thead><tr><th width="280.5999755859375">Error</th><th>Description</th></tr></thead><tbody><tr><td><strong>INVALID_PARTNER</strong></td><td>No partner is set.</td></tr><tr><td><strong>INVALID_PROFORMA_NUMBER</strong></td><td>Your partner invoice number is not valid.</td></tr><tr><td><strong>DUPLICATE_REFUND_REQUEST</strong></td><td>A refund request was already placed for this partner invoice.</td></tr><tr><td><strong>INVALID_PROFORMA</strong></td><td>The partner invoice needs to be paid in order to send a refund request.</td></tr></tbody></table>


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.2checkout.com/channel-manager-api/channel-manager-api/api-2.1/soap-2.1/reference/refunds/request-proforma-refund.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
